
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef zone_POSTER_LIB_H
#define zone_POSTER_LIB_H

#include "posterLib.h"
#include "genom/genom.h"

/* Types definis ou utilises par le module */
#include "zoneType.h"
#include "zoneError.h"

/* 
 * Definition de la SDI_C 
*/
typedef struct {
  CNTRL_TASK_DESCRIPTION cntrlTask;
  EXEC_TASK_DESCRIPTION execTaskTab[ZONE_NB_EXEC_TASK];
  ACTIVITY_DESCRIPTION activityTab[MAX_ACTIVITIES];
} ZONE_CNTRL_STR;

/* For consistency with other posters */
typedef ZONE_CNTRL_STR ZONE_CNTRL_POSTER_STR;
 
/* 
 * Definition des structures de posters
 */
#include "zonePosterLibStruct.h"



/* Posters */
#define ZONE_CNTRL_POSTER_NAME genomInstanceSuffixName("zone", "Cntrl")
#define ZONE_TARGETMAP_POSTER_NAME genomInstanceSuffixName("zone", "TARGETMap")
#define ZONE_TARGETROBOTIN_POSTER_NAME genomInstanceSuffixName("zone", "TARGETRobotIn")
#define ZONE_SPECIALMAP_POSTER_NAME genomInstanceSuffixName("zone", "SPECIALMap")
#define ZONE_SPECIALROBOTIN_POSTER_NAME genomInstanceSuffixName("zone", "SPECIALRobotIn")
#define ZONE_SPECIALMOBILE1IN_POSTER_NAME genomInstanceSuffixName("zone", "SPECIALMobile1In")
#define ZONE_SPECIALMOBILE2IN_POSTER_NAME genomInstanceSuffixName("zone", "SPECIALMobile2In")
#define ZONE_SPECIALMOBILE3IN_POSTER_NAME genomInstanceSuffixName("zone", "SPECIALMobile3In")
#define ZONE_VIRTUAL_OBSTMAP_POSTER_NAME genomInstanceSuffixName("zone", "VIRTUAL_OBSTMap")
#define ZONE_VIRTUAL_OBSTROBOTIN_POSTER_NAME genomInstanceSuffixName("zone", "VIRTUAL_OBSTRobotIn")
#define ZONE_NAVMAP_POSTER_NAME genomInstanceSuffixName("zone", "NavMap")
#define ZONE_NAVOBSTS_POSTER_NAME genomInstanceSuffixName("zone", "NavObsts")


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif
extern STATUS zonePosterInit ( void );
extern POSTER_ID zoneCntrlPosterID ();
extern STATUS zoneCntrlPosterRead ( ZONE_CNTRL_STR *zoneCntrlStrId );
extern STATUS zoneCntrlPosterInit ( void );
extern STATUS zoneCntrlInstancePosterRead(const char *name, ZONE_CNTRL_STR *zoneCntrlStrId);
extern STATUS zoneTARGETMapPosterInit ( void );
extern POSTER_ID zoneTARGETMapPosterID ( void );
extern STATUS zoneTARGETMapPosterRead ( ZONE_TARGETMAP_POSTER_STR *x );
extern STATUS zoneTARGETMapInstancePosterRead ( const char *, ZONE_TARGETMAP_POSTER_STR * );
extern STATUS zoneTARGETMapZONES_MAPPosterRead ( ZONES_MAP *ZONES_MAP );
extern STATUS zoneTARGETMapZONES_MAPInstancePosterRead( const char *, ZONES_MAP * );
extern STATUS zoneTARGETRobotInPosterInit ( void );
extern POSTER_ID zoneTARGETRobotInPosterID ( void );
extern STATUS zoneTARGETRobotInPosterRead ( ZONE_TARGETROBOTIN_POSTER_STR *x );
extern STATUS zoneTARGETRobotInInstancePosterRead ( const char *, ZONE_TARGETROBOTIN_POSTER_STR * );
extern STATUS zoneTARGETRobotInZONES_OCCUPIEDPosterRead ( ZONES_OCCUPIED *ZONES_OCCUPIED );
extern STATUS zoneTARGETRobotInZONES_OCCUPIEDInstancePosterRead( const char *, ZONES_OCCUPIED * );
extern STATUS zoneSPECIALMapPosterInit ( void );
extern POSTER_ID zoneSPECIALMapPosterID ( void );
extern STATUS zoneSPECIALMapPosterRead ( ZONE_SPECIALMAP_POSTER_STR *x );
extern STATUS zoneSPECIALMapInstancePosterRead ( const char *, ZONE_SPECIALMAP_POSTER_STR * );
extern STATUS zoneSPECIALMapZONES_MAPPosterRead ( ZONES_MAP *ZONES_MAP );
extern STATUS zoneSPECIALMapZONES_MAPInstancePosterRead( const char *, ZONES_MAP * );
extern STATUS zoneSPECIALRobotInPosterInit ( void );
extern POSTER_ID zoneSPECIALRobotInPosterID ( void );
extern STATUS zoneSPECIALRobotInPosterRead ( ZONE_SPECIALROBOTIN_POSTER_STR *x );
extern STATUS zoneSPECIALRobotInInstancePosterRead ( const char *, ZONE_SPECIALROBOTIN_POSTER_STR * );
extern STATUS zoneSPECIALRobotInZONES_OCCUPIEDPosterRead ( ZONES_OCCUPIED *ZONES_OCCUPIED );
extern STATUS zoneSPECIALRobotInZONES_OCCUPIEDInstancePosterRead( const char *, ZONES_OCCUPIED * );
extern STATUS zoneSPECIALMobile1InPosterInit ( void );
extern POSTER_ID zoneSPECIALMobile1InPosterID ( void );
extern STATUS zoneSPECIALMobile1InPosterRead ( ZONE_SPECIALMOBILE1IN_POSTER_STR *x );
extern STATUS zoneSPECIALMobile1InInstancePosterRead ( const char *, ZONE_SPECIALMOBILE1IN_POSTER_STR * );
extern STATUS zoneSPECIALMobile1InZONES_OCCUPIEDPosterRead ( ZONES_OCCUPIED *ZONES_OCCUPIED );
extern STATUS zoneSPECIALMobile1InZONES_OCCUPIEDInstancePosterRead( const char *, ZONES_OCCUPIED * );
extern STATUS zoneSPECIALMobile2InPosterInit ( void );
extern POSTER_ID zoneSPECIALMobile2InPosterID ( void );
extern STATUS zoneSPECIALMobile2InPosterRead ( ZONE_SPECIALMOBILE2IN_POSTER_STR *x );
extern STATUS zoneSPECIALMobile2InInstancePosterRead ( const char *, ZONE_SPECIALMOBILE2IN_POSTER_STR * );
extern STATUS zoneSPECIALMobile2InZONES_OCCUPIEDPosterRead ( ZONES_OCCUPIED *ZONES_OCCUPIED );
extern STATUS zoneSPECIALMobile2InZONES_OCCUPIEDInstancePosterRead( const char *, ZONES_OCCUPIED * );
extern STATUS zoneSPECIALMobile3InPosterInit ( void );
extern POSTER_ID zoneSPECIALMobile3InPosterID ( void );
extern STATUS zoneSPECIALMobile3InPosterRead ( ZONE_SPECIALMOBILE3IN_POSTER_STR *x );
extern STATUS zoneSPECIALMobile3InInstancePosterRead ( const char *, ZONE_SPECIALMOBILE3IN_POSTER_STR * );
extern STATUS zoneSPECIALMobile3InZONES_OCCUPIEDPosterRead ( ZONES_OCCUPIED *ZONES_OCCUPIED );
extern STATUS zoneSPECIALMobile3InZONES_OCCUPIEDInstancePosterRead( const char *, ZONES_OCCUPIED * );
extern STATUS zoneVIRTUAL_OBSTMapPosterInit ( void );
extern POSTER_ID zoneVIRTUAL_OBSTMapPosterID ( void );
extern STATUS zoneVIRTUAL_OBSTMapPosterRead ( ZONE_VIRTUAL_OBSTMAP_POSTER_STR *x );
extern STATUS zoneVIRTUAL_OBSTMapInstancePosterRead ( const char *, ZONE_VIRTUAL_OBSTMAP_POSTER_STR * );
extern STATUS zoneVIRTUAL_OBSTMapZONES_MAPPosterRead ( ZONES_MAP *ZONES_MAP );
extern STATUS zoneVIRTUAL_OBSTMapZONES_MAPInstancePosterRead( const char *, ZONES_MAP * );
extern STATUS zoneVIRTUAL_OBSTRobotInPosterInit ( void );
extern POSTER_ID zoneVIRTUAL_OBSTRobotInPosterID ( void );
extern STATUS zoneVIRTUAL_OBSTRobotInPosterRead ( ZONE_VIRTUAL_OBSTROBOTIN_POSTER_STR *x );
extern STATUS zoneVIRTUAL_OBSTRobotInInstancePosterRead ( const char *, ZONE_VIRTUAL_OBSTROBOTIN_POSTER_STR * );
extern STATUS zoneVIRTUAL_OBSTRobotInZONES_OCCUPIEDPosterRead ( ZONES_OCCUPIED *ZONES_OCCUPIED );
extern STATUS zoneVIRTUAL_OBSTRobotInZONES_OCCUPIEDInstancePosterRead( const char *, ZONES_OCCUPIED * );
extern STATUS zoneNavMapPosterInit ( void );
extern POSTER_ID zoneNavMapPosterID ( void );
extern STATUS zoneNavMapPosterRead ( ZONE_NAVMAP_POSTER_STR *x );
extern STATUS zoneNavMapInstancePosterRead ( const char *, ZONE_NAVMAP_POSTER_STR * );
extern STATUS zoneNavMapMapPosterRead ( SEGLOC_MAP *Map );
extern STATUS zoneNavMapMapInstancePosterRead( const char *, SEGLOC_MAP * );
extern STATUS zoneNavObstsPosterInit ( void );
extern POSTER_ID zoneNavObstsPosterID ( void );
extern STATUS zoneNavObstsPosterRead ( ZONE_NAVOBSTS_POSTER_STR *x );
extern STATUS zoneNavObstsInstancePosterRead ( const char *, ZONE_NAVOBSTS_POSTER_STR * );
extern STATUS zoneNavObstsHeaderPosterRead ( ZONE_OBSTS_IN_NAV_MAP_HEADER *Header );
extern STATUS zoneNavObstsHeaderInstancePosterRead( const char *, ZONE_OBSTS_IN_NAV_MAP_HEADER * );
extern STATUS zoneNavObstsObstaclesPosterRead ( ZONE_OBSTS_IN_NAV_MAP_OBSTS *Obstacles );
extern STATUS zoneNavObstsObstaclesInstancePosterRead( const char *, ZONE_OBSTS_IN_NAV_MAP_OBSTS * );
#ifdef __cplusplus
}
#endif
#endif

